#!/bin/bash

typeset -i max_log_lines_to_show
max_log_lines_to_show=512

show_audit_logs ()
{

# Do not allow the cli / error the cli in FIPS mode.
# Following lines are copied from /vobs/projects/springboard/fabos/src/vcs/dcm/build/scripts/foscmd
# [
FIPSCFGFILE="/etc/fabos/fips_selftests.conf"
if [ -r $FIPSCFGFILE ]
then 
	read rc <$FIPSCFGFILE
	if [ $rc == "1" ] || [ $rc == "2" ] || [ $rc == "3" ]; then
		echo "Command disabled in FIPS mode."
		exit 1;
	fi
fi
# ]

typeset -i numberOfLines

numberOfLines=`cat /var/confd/log/audit.log_ $(ls -r /var/confd/log/audit.log.* 2>/dev/null) /var/confd/log/audit.log 2>/dev/null | wc -l`

if [ 0 -ne $numberOfLines ]
then
    #     20-Feb-2013::00:44:34.799     admin/6  'show vcs'
    echo "          Date                 User            Command"
    echo "------------------------------------------------------------------------------"

    if [ $max_log_lines_to_show -lt $numberOfLines ]
    then
        echo "(Log has been rotated.)"
    fi

    cat /var/confd/log/audit.log_ $(ls -r /var/confd/log/audit.log.* 2>/dev/null) /var/confd/log/audit.log 2>/dev/null | 
    grep --text 'CLI'                               | 
    grep -v 'CLI done$'                             | 
    tail -$max_log_lines_to_show                    |
    sed -e 's/ftp:\/\/.*\@/ftp:\/\//'               | 
    sed -e 's/scp:\/\/.*\@/scp:\/\//'               | 
    sed -e 's/password\s*.*\s/password PASSWORD /'  |
    sed -e 's/password.*$/password/'                |
    awk '{$1=$3=$4=$5=$6=$8=""; print $0}'
fi

}

pre_rotate_audit_log ()
{

lastLogFile=`ls -r /var/confd/log/audit.log.*  2>/dev/null | head -1`

if [ "" != "$lastLogFile" ]
then
    cat $lastLogFile | grep --text 'CLI' | grep -v 'CLI done$' >> /var/confd/log/audit.log_

    typeset -i max_log_lines_to_keep_in_rotated_file
    max_log_lines_to_keep_in_rotated_file=$(($max_log_lines_to_show + 1))

    tail -$max_log_lines_to_keep_in_rotated_file /var/confd/log/audit.log_ > /var/confd/log/audit.log_.tmp
    mv /var/confd/log/audit.log_.tmp /var/confd/log/audit.log_
fi

}

if [ $# -eq 1 ]
then
    if [ "$1" == "--prerotate" ]
    then
        pre_rotate_audit_log
    else
        show_audit_logs
    fi
else
    show_audit_logs
fi
